#include <stdlib.h>
#include <stdio.h>
#include <string.h>

char _PROG_NAME[]= "ToHTML" ;
#define PROGRAM_VERSION "1.01"
#define TRUE 1
#define FALSE 0

void help() {

  /* Display the options */

  printf("\nToHTML v%s (c) Adrian.D.Ives\n\n", PROGRAM_VERSION) ;

  printf("Convert stdin to an HTML stream on stdout.\n\n") ;

  printf("-tTitle       Set the title of the output document\n") ;
  printf("-fChars       Force lines beginning with any of these Chars to\n") ;
  printf("              begin a new paragraph.\n\n") ;

}

char *escape(char *result, char *text) {

  int i ;

  if ( (strpos(text, '<') != -1) ||
       (strpos(text, '>') != -1) ||
       (strpos(text, '&') != -1)
     ) {

    char *ptr ;
    int index ;

    *result= 0 ;
    index= 0 ;
    ptr= text ;
    while (*ptr) {
      if ( *ptr == '>' ) {
	strcpy(result + index, "&gt;") ;
	index+= 4 ;
      }
      else
      if ( *ptr == '<' ) {
	strcpy(result + index, "&lt;") ;
	index+= 4 ;
      }
      else
      if ( *ptr == '&' ) {
	strcpy(result + index, "&amp;") ;
	index+= 5 ;
      }
      else
	result[index++]= *ptr ;
      ptr++ ;
    }
    result[index]= 0 ;
  }
  else
    strcpy(result, text) ;
  return result ;
}

main(int argc, char **argv) {

  char title[256], line[256], escd[1300], force[64], *l ;
  int i, inPre ;

  strcpy(title, "An HTML Page") ;
  *force= 0 ;
  for ( i= 1 ; i <= argc - 1 ; i++ ) {
    if ( argv[i][0] == '-' ) {
      switch( argv[i][1] ) {
	case  0  :
	case '?' :
	  help() ;
	  return 0 ;
	case 't' :
	  strcpy(title, argv[i] + 2) ;
	case 'f' :
	  strcpy(force, argv[i] + 2) ;
      }
    }
  }

  printf("<HTML>\n<HEAD>\n") ;
  printf("<TITLE>%s</TITLE>\n", title) ;
  printf("</HEAD>\n") ;
  printf("<BODY>\n") ;

  l= line ;
  inPre= FALSE ;
  while ( l && !feof(stdin) ) {
    l= fgets(line, 255, stdin) ;
    if ( l ) {
      l= escape(escd, l) ;
      if ( *l == ' ' || *l == '\t' || ( inPre && *l == '\n' ) )

	/* Lines beginning with a space or a tab keep their formatting */

	if ( inPre )
	  printf("%s", l) ;
	else {
	  printf("<PRE>\n%s", l) ;
	  inPre= TRUE ;
	}
      else {
	if ( inPre ) {
	  printf("</PRE>\n<P>%s", l) ;
	  inPre= FALSE ;
	}
	else {
	  if ( *l == '\n' )
	    printf("<P>\n") ;
	  else
	  if ( *force ) {
	    if ( strpos(force, *l) != -1 )
	      printf("<P>%s", l) ;
	    else
	      printf("%s", l) ;
	  }
	  else
	    printf("%s", l) ;
	}
      }
    }
  }
  if ( inPre )
    printf("\n</PRE>") ;
  printf("</BODY>\n</HTML>\n") ;

  return 0 ;
}
